_ALLREPOS/blog-on-rails/config/routes.rb
Blog::Application.routes.draw do
  

  get "sessions/destroy"
  get "sessions/new"
  get "home/index"
  get "admin/index"
  get "contact/index"
  get "about/index"  
  get "portfolio/index"
  
  resources :contacts #, only: [:new, :create]
  resources :sessions
  resources :users
  resources :tags       #get "tags/show"
  resources :projects
  resources :companies
  resources :posts do
    resources :comments
  end
  
  match 'register', :to => 'users#new'
  match 'login', :to => 'sessions#new'
  match 'logout', :to => 'sessions#destroy'
  match 'contactme', :to => 'contacts#new'
  match 'about', :to => 'about#index'
  match 'portfolio', :to => 'portfolio#index'
  match 'blog', :to => 'posts#index'
  match 'sitemap', to: 'sitemap#index'
  
  match 'rss', to: 'sitemap#rss'
  match 'feed', to: 'sitemap#rss'
  match 'feed.rss', to: 'sitemap#rss'
 

  root :to => 'home#index'

end

_ALLREPOS/blog-on-rails/app/models/post.rb
class Post < ActiveRecord::Base
  extend FriendlyId
  before_validation :check_tags
  
  friendly_id :title, use: [:slugged, :history]
  
  #validates :name, :presence => true
  validates :title, :presence => true, :length => { :minimum => 2}

  belongs_to :user  
  has_many :comments, dependent: :destroy, :autosave => true
  has_and_belongs_to_many :tags, :autosave => true
  
  accepts_nested_attributes_for :tags, allow_destroy: :true, 
    reject_if: proc{ |attrs| attrs.all?{|k,v| v.blank? } }
	
	
  private
	# Use an existing tag if it already exists.
	def check_tags
		tags.map! do |tag|
			existing_tag = Tag.find_by_name(tag.name)
			(existing_tag)? existing_tag : tag
		end
	end
end

=begin
	In a create operation under Rails, there are six callbacks before the database operation, and two after. In order, these are:

	before_validation
	before_validation_on_create
	after_validation
	after_validation_on_create
	before_save
	before_create
	DATABASE INSERT
	after_create
	after_save
=end

_ALLREPOS/blog-on-rails/app/controllers/posts_controller.rb
include ApplicationHelper

class PostsController < ApplicationController
  #http_basic_authenticate_with name: "admin", password: "1234", except: [:index, :show]
  before_filter :require_login, :except => [:index, :show]
  
  # GET /posts
  # GET /posts.json
  def index
    @title = "Blog"
    @posts = Post.all order: "updated_at DESC"

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @posts }
    end
  end

  # GET /posts/1
  # GET /posts/1.json
  def show
    @post = Post.find(params[:id])
=begin    
    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @post }
    end
=end    
    if request.path != post_path(@post)
      redirect_to @post, status: :moved_permanently
    end
    
  end

  # GET /posts/new
  # GET /posts/new.json
  def new
    @post = Post.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @post }
    end
  end

  # GET /posts/1/edit
  def edit
    @post = Post.find(params[:id])
  end

  # POST /posts
  # POST /posts.json
  def create
    @post = current_user.posts.create(params[:post])
    # TODO sanitize @post.body, :tags => %w(script style), :attributes => %w(id class style)
    respond_to do |format|
      if @post.save
        format.html { redirect_to @post, notice: 'Post was successfully created.' }
        format.json { render json: @post, status: :created, location: @post }
      else
        format.html { render action: "new" }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /posts/1
  # PUT /posts/1.json
  def update
    @post = Post.find(params[:id])

    respond_to do |format|
      if @post.update_attributes(params[:post])
        format.html { redirect_to @post, notice: 'Post was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /posts/1
  # DELETE /posts/1.json
  def destroy
    @post = Post.find(params[:id])
    @post.destroy

    respond_to do |format|
      format.html { redirect_to posts_url }
      format.json { head :no_content }
    end
  end
end

_ALLREPOS/blog-on-rails/app/helpers/posts_helper.rb
module PostsHelper
  def post_tags(post)
    post.tags.map { |t| link_to(t.name, t) }.join(", ") if not post.tags.nil?
  end
end

_ALLREPOS/blog-on-rails/app/views/posts/_form.html.haml
- content_for :title  do
	Create a new Post | Adrian Mejia's Blog
	
- content_for :stylesheets do
	= stylesheet_link_tag "bootstrap-wysihtml5-0.0.2"
	=# stylesheet_link_tag "wysihtml5/bootstrap-wysihtml5"
	=# stylesheet_link_tag "bootstrap-wysihtml5"
	
- content_for :javascripts do
	= javascript_include_tag "wysihtml5-0.3.0_rc3"
	= javascript_include_tag "bootstrap-wysihtml5-0.0.2.min"
	=# javascript_include_tag "wysihtml5/wysihtml5-0.3.0_rc2.min"
	=# javascript_include_tag "wysihtml5/bootstrap-wysihtml5"
	=# javascript_include_tag "wysihtml5-0.3.0_rc2.min"
	=# javascript_include_tag "bootstrap-wysihtml5"
	%script{type: "text/javascript"}
		:plain
			$("#post_content").wysihtml5();

- @post.tags.build
= form_for @post do |f|
	-if @post.errors.any?
		#error_explanation
			%h2= "#{pluralize(@post.errors.count, "error")} prohibited this post from being saved:"
			%ul
				- @post.errors.full_messages.each do |msg|
					%li= msg
	.field
		= f.label :title
		= f.text_field :title
	.field
		= f.label :content
		= f.text_area :content, style: "width: 100%; height: 40%;"
	%h2 Tags:
	= render :partial => 'tags/form', :locals => {:form => f}
	.actions
		= f.submit 'Save'

_ALLREPOS/blog-on-rails/app/views/posts/edit.html.haml
%h1 Editing post

= render 'form'

= link_to 'Show', @post
=# link_to 'Back', posts_path

_ALLREPOS/blog-on-rails/app/views/posts/index.html.haml
- content_for :title do
	Blog | articles about technology, programming, software development tips and experiences.
	
%h1 Articles

- if @posts.empty?
	%p No posts
- else
	- @posts.each do |post|
		%article
			%h2= link_to post.title, post
			-# by #{link_to "#{post.user.name}", post.user} in
			%p.details=raw "#{l post.created_at, format: :post}"
			%p=raw truncate(strip_tags(post.content), length: 600, omission: "... #{link_to "Read more", post }")
			%p.tags=raw "Tags: #{post_tags(post)}"
			%p.comments= pluralize(post.comments.length, "comment") + "." if post.comments.length > 0

_ALLREPOS/blog-on-rails/app/views/posts/new.html.haml
%h1 New post

= render 'form'

=# link_to 'Back', posts_path

_ALLREPOS/blog-on-rails/app/views/posts/show.html.haml
- content_for :title do
	= "#{@post.title} | Adrian Mejia's Blog"

- content_for :meta_description do
	= "#{truncate(strip_tags(@post.content),length: 160, omission: "...")}"

- content_for :meta_keywords do
	= "#{strip_tags(post_tags(@post))}"
	
%p#notice= notice
= render "layouts/flash_errors"

-if signed_in?
	%div.pull-right=raw "#{link_to 'edit', edit_post_path(@post)} | #{link_to 'delete', @post, :confirm => 'Are you sure?', :method => :delete}"

%h1= @post.title
%p.details=raw "by #{@post.user.name} in #{l @post.created_at, format: :post} #{(l(@post.updated_at, format: :post) != l(@post.created_at, format: :post))? " and last update was in #{l @post.updated_at, format: :post}":"" }"
%p=raw @post.content
%b.tags Tags: 
=raw post_tags(@post)

%hr
/%h2= "#{pluralize(@post.comments.length, "Comment")}"
/= render @post.comments if @post.comments.exists?

%hr
%h2 Add a new comment
=# render "comments/form"

= render "comments/disqus"

=# link_to 'Back', posts_path